Index: /trunk/src/VBox/Installer/win/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Installer/win/Makefile.kmk	(revision 51027)
+++ /trunk/src/VBox/Installer/win/Makefile.kmk	(revision 51028)
@@ -57,4 +57,14 @@
 #
 VBOX_INSTALLER_MERGE_MODULES = App USB NetAdp NetFlt Python
+
+#
+# Use merge modules if we're not doing an official release.
+# This will increase the overall installer size significantly because
+# merge modules are not able to use a common .cab file to reduce their
+# size.
+#
+ifneq ($(int-mod $(VBOX_VERSION_BUILD),2),0)
+ VBOX_WITH_MSM_INSTALL := 1
+endif
 
 #
@@ -144,11 +154,11 @@
 
 ifdef VBOX_WITH_MSM_INSTALL
- $(foreach module,$(VBOX_INSTALLER_MERGE_MODULES), \
- 	$(foreach lang,$(VBOX_INSTALLER_LANGUAGES), \
-		OTHER_CLEAN += \
-			$(VBOX_WIN_INST_OUT_DIR)/VBoxMerge$(module).msm.dep \
-			$(VBOX_WIN_INST_OUT_DIR)/VBoxMerge$(module)_$(lang).msm \
-			$(VBOX_WIN_INST_OUT_DIR)/VBoxMerge$(module)_$(lang).wixobj \
-			$(VBOX_WIN_INST_OUT_DIR)/VBoxMerge$(module)_$(lang).wixpdb))
+ OTHER_CLEAN += \
+  $(foreach module,$(VBOX_INSTALLER_MERGE_MODULES), \
+   $(foreach lang,$(VBOX_INSTALLER_LANGUAGES), \
+		$(VBOX_WIN_INST_OUT_DIR)/VBoxMerge$(module).msm.dep \
+		$(VBOX_WIN_INST_OUT_DIR)/VBoxMerge$(module)_$(lang).msm \
+		$(VBOX_WIN_INST_OUT_DIR)/VBoxMerge$(module)_$(lang).wixobj \
+		$(VBOX_WIN_INST_OUT_DIR)/VBoxMerge$(module)_$(lang).wixpdb))
 endif
 
@@ -633,5 +643,5 @@
 	$(SED) -f $(VBOX_PATH_WIN_INST_SRC)/dep.sed \
 		--append $(VBOX_WIN_INST_OUT_DIR)/VBoxMerge$(module).msm.dep \
-		$(VBOX_PATH_WIN_INST_SRC)/VBoxMerge$(module).wxs \
+		$(VBOX_PATH_WIN_INST_SRC)/VBoxMerge$(module).wxi \
 		$(VBOX_PATH_WIN_INST_SRC)/UserInterface.wxi \
 		$(VBOX_WIN_INST_OUT_DIR)/VirtualBox_TypeLib.wxi \
Index: /trunk/src/VBox/Installer/win/VBoxMergeApp.wxs
===================================================================
--- /trunk/src/VBox/Installer/win/VBoxMergeApp.wxs	(revision 51027)
+++ /trunk/src/VBox/Installer/win/VBoxMergeApp.wxs	(revision 51028)
@@ -54,9 +54,10 @@
 
                 <?include VBoxMergeApp.wxi ?>
-                <?include VBoxMergeAppCA.wxi ?>
 
             </Directory> <!-- MergeRedirectFolder directory -->
         </Directory> <!-- TARGETDIR -->
 
+        <?include VBoxMergeAppCA.wxi ?>
+
     </Module>
 </Wix>
Index: /trunk/src/VBox/Installer/win/VBoxMergeNetFlt.wxs
===================================================================
--- /trunk/src/VBox/Installer/win/VBoxMergeNetFlt.wxs	(revision 51027)
+++ /trunk/src/VBox/Installer/win/VBoxMergeNetFlt.wxs	(revision 51028)
@@ -39,9 +39,10 @@
 
                 <?include VBoxMergeNetFlt.wxi ?>
-                <?include VBoxMergeNetFltCA.wxi ?>
 
             </Directory> <!-- MergeRedirectFolder -->
         </Directory> <!-- TARGETDIR -->
 
+        <?include VBoxMergeNetFltCA.wxi ?>
+
     </Module>
 </Wix>
Index: /trunk/src/VBox/Installer/win/VBoxMergePython.wxs
===================================================================
--- /trunk/src/VBox/Installer/win/VBoxMergePython.wxs	(revision 51027)
+++ /trunk/src/VBox/Installer/win/VBoxMergePython.wxs	(revision 51028)
@@ -39,9 +39,10 @@
 
                 <?include VBoxMergePython.wxi ?>
-                <?include VBoxMergePythonCA.wxi ?>
 
             </Directory> <!-- MergeRedirectFolder -->
         </Directory> <!-- TARGETDIR -->
 
+        <?include VBoxMergePythonCA.wxi ?>
+
     </Module>
 </Wix>
Index: /trunk/src/VBox/Installer/win/VBoxMergePythonCA.wxi
===================================================================
--- /trunk/src/VBox/Installer/win/VBoxMergePythonCA.wxi	(revision 51027)
+++ /trunk/src/VBox/Installer/win/VBoxMergePythonCA.wxi	(revision 51028)
@@ -1,17 +1,2 @@
-<?xml version="1.0"?>
-<!--
-    VirtualBox Windows Installation Script (WiX)
-
-    Copyright (C) 2006-2014 Oracle Corporation
-
-    This file is part of VirtualBox Open Source Edition (OSE), as
-    available from http://www.virtualbox.org. This file is free software;
-    you can redistribute it and/or modify it under the terms of the GNU
-    General Public License (GPL) as published by the Free Software
-    Foundation, in version 2 as it comes in the "COPYING" file of the
-    VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-    hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
--->
-
 <?xml version="1.0"?>
 <!--