Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 51034)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 51035)
@@ -278,5 +278,5 @@
 	src/extensions/QIAdvancedToolBar.h \
 	src/extensions/graphics/QIGraphicsWidget.h \
-	src/extradata/UIExtraDataEventHandler.h \
+	src/extradata/UIExtraDataManager.h \
 	src/globals/UIActionPool.h \
 	src/globals/UIAnimationFramework.h \
@@ -471,5 +471,5 @@
 	src/extensions/QISplitter.cpp \
 	src/extensions/QIAdvancedToolBar.cpp \
-	src/extradata/UIExtraDataEventHandler.cpp \
+	src/extradata/UIExtraDataManager.cpp \
 	src/globals/UIActionPool.cpp \
 	src/globals/UIThreadPool.cpp \
@@ -544,5 +544,5 @@
 	src/extensions/QIAdvancedToolBar.cpp \
 	src/extensions/graphics/QIGraphicsWidget.cpp \
-	src/extradata/UIExtraDataEventHandler.cpp \
+	src/extradata/UIExtraDataManager.cpp \
 	src/globals/UIDefs.cpp \
 	src/globals/COMDefs.cpp \
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataEventHandler.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataEventHandler.cpp	(revision 51034)
+++ 	(revision )
@@ -1,224 +1,0 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt GUI ("VirtualBox"):
- * UIExtraDataEventHandler class implementation
- */
-
-/*
- * Copyright (C) 2010-2013 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-/* Qt includes: */
-#include <QMutex>
-
-/* GUI includes: */
-#include "UIExtraDataEventHandler.h"
-#include "UIMainEventListener.h"
-#include "VBoxGlobal.h"
-#include "VBoxGlobalSettings.h"
-#include "UIActionPool.h"
-
-/* COM includes: */
-#include "COMEnums.h"
-#include "CEventSource.h"
-
-class UIExtraDataEventHandlerPrivate: public QObject
-{
-    Q_OBJECT;
-
-public:
-
-    UIExtraDataEventHandlerPrivate(QObject *pParent = 0)
-        : QObject(pParent)
-    {}
-
-public slots:
-
-    void sltExtraDataCanChange(QString strId, QString strKey, QString strValue, bool &fVeto, QString &strVetoReason)
-    {
-        if (QUuid(strId).isNull())
-        {
-            /* it's a global extra data key someone wants to change */
-            if (strKey.startsWith("GUI/"))
-            {
-                /* Try to set the global setting to check its syntax */
-                VBoxGlobalSettings gs(false /* non-null */);
-                if (gs.setPublicProperty (strKey, strValue))
-                {
-                    /* this is a known GUI property key */
-                    if (!gs)
-                    {
-                        strVetoReason = gs.lastError();
-                        /* disallow the change when there is an error*/
-                        fVeto = true;
-                    }
-                    return;
-                }
-            }
-        }
-    }
-
-    void sltExtraDataChange(QString strId, QString strKey, QString strValue)
-    {
-        if (QUuid(strId).isNull())
-        {
-            if (strKey.startsWith ("GUI/"))
-            {
-                if (strKey == GUI_LanguageId)
-                    emit sigGUILanguageChange(strValue);
-                if (strKey == GUI_Input_SelectorShortcuts && gActionPool->type() == UIActionPoolType_Selector)
-                    emit sigSelectorShortcutsChanged();
-                if (strKey == GUI_Input_MachineShortcuts && gActionPool->type() == UIActionPoolType_Runtime)
-                    emit sigMachineShortcutsChanged();
-#ifdef Q_WS_MAC
-                if (strKey == GUI_PresentationModeEnabled)
-                {
-                    /* Default to true if it is an empty value */
-                    QString testStr = strValue.toLower();
-                    bool f = (testStr.isEmpty() || testStr == "false");
-                    emit sigPresentationModeChange(f);
-                }
-#endif /* Q_WS_MAC */
-
-                m_mutex.lock();
-                vboxGlobal().settings().setPublicProperty(strKey, strValue);
-                m_mutex.unlock();
-                Assert(!!vboxGlobal().settings());
-            }
-        }
-        else if (vboxGlobal().isVMConsoleProcess())
-        {
-            /* Take care about HID LEDs sync */
-            if (strKey == GUI_HidLedsSync)
-            {
-                /* If extra data GUI/HidLedsSync is not present in VM config or set
-                 * to 1 then sync is enabled. Otherwise, it is disabled. */
-                bool f = (strValue.isEmpty() || strValue == "1") ? true : false;
-                emit sigHidLedsSyncStateChanged(f);
-            }
-
-#ifdef Q_WS_MAC
-            /* Check for the currently running machine */
-            if (strId == vboxGlobal().managedVMUuid())
-            {
-                if (   strKey == GUI_RealtimeDockIconUpdateEnabled
-                    || strKey == GUI_RealtimeDockIconUpdateMonitor)
-                {
-                    bool f = strValue.toLower() == "false" ? false : true;
-                    emit sigDockIconAppearanceChange(f);
-                }
-            }
-#endif /* Q_WS_MAC */
-        }
-    }
-
-signals:
-
-    void sigGUILanguageChange(QString strLang);
-    void sigSelectorShortcutsChanged();
-    void sigMachineShortcutsChanged();
-    void sigHidLedsSyncStateChanged(bool fEnabled);
-#ifdef RT_OS_DARWIN
-    void sigPresentationModeChange(bool fEnabled);
-    void sigDockIconAppearanceChange(bool fEnabled);
-#endif /* RT_OS_DARWIN */
-
-private:
-
-    /** protects #OnExtraDataChange() */
-    QMutex m_mutex;
-};
-
-/* static */
-UIExtraDataEventHandler *UIExtraDataEventHandler::m_pInstance = 0;
-
-/* static */
-UIExtraDataEventHandler* UIExtraDataEventHandler::instance()
-{
-    if (!m_pInstance)
-        m_pInstance = new UIExtraDataEventHandler();
-    return m_pInstance;
-}
-
-/* static */
-void UIExtraDataEventHandler::destroy()
-{
-    if (m_pInstance)
-    {
-        delete m_pInstance;
-        m_pInstance = 0;
-    }
-}
-
-UIExtraDataEventHandler::UIExtraDataEventHandler()
-  : m_pHandler(new UIExtraDataEventHandlerPrivate(this))
-{
-//    RTPrintf("Self add: %RTthrd\n", RTThreadSelf());
-    const CVirtualBox &vbox = vboxGlobal().virtualBox();
-    ComObjPtr<UIMainEventListenerImpl> pListener;
-    pListener.createObject();
-    pListener->init(new UIMainEventListener(), this);
-    m_mainEventListener = CEventListener(pListener);
-    QVector<KVBoxEventType> events;
-    events
-        << KVBoxEventType_OnExtraDataCanChange
-        << KVBoxEventType_OnExtraDataChanged;
-
-    vbox.GetEventSource().RegisterListener(m_mainEventListener, events, TRUE);
-    AssertWrapperOk(vbox);
-
-    /* This is a vetoable event, so we have to respond to the event and have to
-     * use a direct connection therefor. */
-    connect(pListener->getWrapped(), SIGNAL(sigExtraDataCanChange(QString, QString, QString, bool&, QString&)),
-            m_pHandler, SLOT(sltExtraDataCanChange(QString, QString, QString, bool&, QString&)),
-            Qt::DirectConnection);
-
-    /* Use a direct connection to the helper class. */
-    connect(pListener->getWrapped(), SIGNAL(sigExtraDataChange(QString, QString, QString)),
-            m_pHandler, SLOT(sltExtraDataChange(QString, QString, QString)),
-            Qt::DirectConnection);
-
-    /* UI signals */
-    connect(m_pHandler, SIGNAL(sigGUILanguageChange(QString)),
-            this, SIGNAL(sigGUILanguageChange(QString)),
-            Qt::QueuedConnection);
-
-    connect(m_pHandler, SIGNAL(sigSelectorShortcutsChanged()),
-            this, SIGNAL(sigSelectorShortcutsChanged()),
-            Qt::QueuedConnection);
-
-    connect(m_pHandler, SIGNAL(sigMachineShortcutsChanged()),
-            this, SIGNAL(sigMachineShortcutsChanged()),
-            Qt::QueuedConnection);
-
-    connect(m_pHandler, SIGNAL(sigHidLedsSyncStateChanged(bool)),
-            this, SIGNAL(sigHidLedsSyncStateChanged(bool)),
-            Qt::QueuedConnection);
-
-#ifdef Q_WS_MAC
-    connect(m_pHandler, SIGNAL(sigPresentationModeChange(bool)),
-            this, SIGNAL(sigPresentationModeChange(bool)),
-            Qt::QueuedConnection);
-
-    connect(m_pHandler, SIGNAL(sigDockIconAppearanceChange(bool)),
-            this, SIGNAL(sigDockIconAppearanceChange(bool)),
-            Qt::QueuedConnection);
-#endif /* Q_WS_MAC */
-}
-
-UIExtraDataEventHandler::~UIExtraDataEventHandler()
-{
-    const CVirtualBox &vbox = vboxGlobal().virtualBox();
-    vbox.GetEventSource().UnregisterListener(m_mainEventListener);
-}
-
-#include "UIExtraDataEventHandler.moc"
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataEventHandler.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataEventHandler.h	(revision 51034)
+++ 	(revision )
@@ -1,60 +1,0 @@
-/** @file
- *
- * VBox frontends: Qt GUI ("VirtualBox"):
- * UIExtraDataEventHandler class declaration
- */
-
-/*
- * Copyright (C) 2010-2013 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-#ifndef __UIExtraDataEventHandler_h__
-#define __UIExtraDataEventHandler_h__
-
-/* COM includes: */
-#include "CEventListener.h"
-
-/* Forward declarations: */
-class UIExtraDataEventHandlerPrivate;
-
-class UIExtraDataEventHandler: public QObject
-{
-    Q_OBJECT;
-
-public:
-    static UIExtraDataEventHandler* instance();
-    static void destroy();
-
-signals:
-    /* Specialized extra data signals */
-    void sigGUILanguageChange(QString strLang);
-    void sigSelectorShortcutsChanged();
-    void sigMachineShortcutsChanged();
-    void sigHidLedsSyncStateChanged(bool fEnabled);
-#ifdef RT_OS_DARWIN
-    void sigPresentationModeChange(bool fEnabled);
-    void sigDockIconAppearanceChange(bool fEnabled);
-#endif /* RT_OS_DARWIN */
-
-private:
-    UIExtraDataEventHandler();
-    ~UIExtraDataEventHandler();
-
-    /* Private member vars */
-    static UIExtraDataEventHandler *m_pInstance;
-    CEventListener m_mainEventListener;
-    UIExtraDataEventHandlerPrivate *m_pHandler;
-};
-
-#define gEDataEvents UIExtraDataEventHandler::instance()
-
-#endif /* !__UIExtraDataEventHandler_h__ */
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 51035)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 51035)
@@ -0,0 +1,224 @@
+/* $Id$ */
+/** @file
+ *
+ * VBox frontends: Qt GUI ("VirtualBox"):
+ * UIExtraDataManager class implementation
+ */
+
+/*
+ * Copyright (C) 2010-2013 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+/* Qt includes: */
+#include <QMutex>
+
+/* GUI includes: */
+#include "UIExtraDataManager.h"
+#include "UIMainEventListener.h"
+#include "VBoxGlobal.h"
+#include "VBoxGlobalSettings.h"
+#include "UIActionPool.h"
+
+/* COM includes: */
+#include "COMEnums.h"
+#include "CEventSource.h"
+
+class UIExtraDataEventHandler: public QObject
+{
+    Q_OBJECT;
+
+public:
+
+    UIExtraDataEventHandler(QObject *pParent = 0)
+        : QObject(pParent)
+    {}
+
+public slots:
+
+    void sltExtraDataCanChange(QString strId, QString strKey, QString strValue, bool &fVeto, QString &strVetoReason)
+    {
+        if (QUuid(strId).isNull())
+        {
+            /* it's a global extra data key someone wants to change */
+            if (strKey.startsWith("GUI/"))
+            {
+                /* Try to set the global setting to check its syntax */
+                VBoxGlobalSettings gs(false /* non-null */);
+                if (gs.setPublicProperty (strKey, strValue))
+                {
+                    /* this is a known GUI property key */
+                    if (!gs)
+                    {
+                        strVetoReason = gs.lastError();
+                        /* disallow the change when there is an error*/
+                        fVeto = true;
+                    }
+                    return;
+                }
+            }
+        }
+    }
+
+    void sltExtraDataChange(QString strId, QString strKey, QString strValue)
+    {
+        if (QUuid(strId).isNull())
+        {
+            if (strKey.startsWith ("GUI/"))
+            {
+                if (strKey == GUI_LanguageId)
+                    emit sigGUILanguageChange(strValue);
+                if (strKey == GUI_Input_SelectorShortcuts && gActionPool->type() == UIActionPoolType_Selector)
+                    emit sigSelectorShortcutsChanged();
+                if (strKey == GUI_Input_MachineShortcuts && gActionPool->type() == UIActionPoolType_Runtime)
+                    emit sigMachineShortcutsChanged();
+#ifdef Q_WS_MAC
+                if (strKey == GUI_PresentationModeEnabled)
+                {
+                    /* Default to true if it is an empty value */
+                    QString testStr = strValue.toLower();
+                    bool f = (testStr.isEmpty() || testStr == "false");
+                    emit sigPresentationModeChange(f);
+                }
+#endif /* Q_WS_MAC */
+
+                m_mutex.lock();
+                vboxGlobal().settings().setPublicProperty(strKey, strValue);
+                m_mutex.unlock();
+                Assert(!!vboxGlobal().settings());
+            }
+        }
+        else if (vboxGlobal().isVMConsoleProcess())
+        {
+            /* Take care about HID LEDs sync */
+            if (strKey == GUI_HidLedsSync)
+            {
+                /* If extra data GUI/HidLedsSync is not present in VM config or set
+                 * to 1 then sync is enabled. Otherwise, it is disabled. */
+                bool f = (strValue.isEmpty() || strValue == "1") ? true : false;
+                emit sigHidLedsSyncStateChanged(f);
+            }
+
+#ifdef Q_WS_MAC
+            /* Check for the currently running machine */
+            if (strId == vboxGlobal().managedVMUuid())
+            {
+                if (   strKey == GUI_RealtimeDockIconUpdateEnabled
+                    || strKey == GUI_RealtimeDockIconUpdateMonitor)
+                {
+                    bool f = strValue.toLower() == "false" ? false : true;
+                    emit sigDockIconAppearanceChange(f);
+                }
+            }
+#endif /* Q_WS_MAC */
+        }
+    }
+
+signals:
+
+    void sigGUILanguageChange(QString strLang);
+    void sigSelectorShortcutsChanged();
+    void sigMachineShortcutsChanged();
+    void sigHidLedsSyncStateChanged(bool fEnabled);
+#ifdef RT_OS_DARWIN
+    void sigPresentationModeChange(bool fEnabled);
+    void sigDockIconAppearanceChange(bool fEnabled);
+#endif /* RT_OS_DARWIN */
+
+private:
+
+    /** protects #OnExtraDataChange() */
+    QMutex m_mutex;
+};
+
+/* static */
+UIExtraDataManager *UIExtraDataManager::m_pInstance = 0;
+
+/* static */
+UIExtraDataManager* UIExtraDataManager::instance()
+{
+    if (!m_pInstance)
+        m_pInstance = new UIExtraDataManager();
+    return m_pInstance;
+}
+
+/* static */
+void UIExtraDataManager::destroy()
+{
+    if (m_pInstance)
+    {
+        delete m_pInstance;
+        m_pInstance = 0;
+    }
+}
+
+UIExtraDataManager::UIExtraDataManager()
+  : m_pHandler(new UIExtraDataEventHandler(this))
+{
+//    RTPrintf("Self add: %RTthrd\n", RTThreadSelf());
+    const CVirtualBox &vbox = vboxGlobal().virtualBox();
+    ComObjPtr<UIMainEventListenerImpl> pListener;
+    pListener.createObject();
+    pListener->init(new UIMainEventListener(), this);
+    m_mainEventListener = CEventListener(pListener);
+    QVector<KVBoxEventType> events;
+    events
+        << KVBoxEventType_OnExtraDataCanChange
+        << KVBoxEventType_OnExtraDataChanged;
+
+    vbox.GetEventSource().RegisterListener(m_mainEventListener, events, TRUE);
+    AssertWrapperOk(vbox);
+
+    /* This is a vetoable event, so we have to respond to the event and have to
+     * use a direct connection therefor. */
+    connect(pListener->getWrapped(), SIGNAL(sigExtraDataCanChange(QString, QString, QString, bool&, QString&)),
+            m_pHandler, SLOT(sltExtraDataCanChange(QString, QString, QString, bool&, QString&)),
+            Qt::DirectConnection);
+
+    /* Use a direct connection to the helper class. */
+    connect(pListener->getWrapped(), SIGNAL(sigExtraDataChange(QString, QString, QString)),
+            m_pHandler, SLOT(sltExtraDataChange(QString, QString, QString)),
+            Qt::DirectConnection);
+
+    /* UI signals */
+    connect(m_pHandler, SIGNAL(sigGUILanguageChange(QString)),
+            this, SIGNAL(sigGUILanguageChange(QString)),
+            Qt::QueuedConnection);
+
+    connect(m_pHandler, SIGNAL(sigSelectorShortcutsChanged()),
+            this, SIGNAL(sigSelectorShortcutsChanged()),
+            Qt::QueuedConnection);
+
+    connect(m_pHandler, SIGNAL(sigMachineShortcutsChanged()),
+            this, SIGNAL(sigMachineShortcutsChanged()),
+            Qt::QueuedConnection);
+
+    connect(m_pHandler, SIGNAL(sigHidLedsSyncStateChanged(bool)),
+            this, SIGNAL(sigHidLedsSyncStateChanged(bool)),
+            Qt::QueuedConnection);
+
+#ifdef Q_WS_MAC
+    connect(m_pHandler, SIGNAL(sigPresentationModeChange(bool)),
+            this, SIGNAL(sigPresentationModeChange(bool)),
+            Qt::QueuedConnection);
+
+    connect(m_pHandler, SIGNAL(sigDockIconAppearanceChange(bool)),
+            this, SIGNAL(sigDockIconAppearanceChange(bool)),
+            Qt::QueuedConnection);
+#endif /* Q_WS_MAC */
+}
+
+UIExtraDataManager::~UIExtraDataManager()
+{
+    const CVirtualBox &vbox = vboxGlobal().virtualBox();
+    vbox.GetEventSource().UnregisterListener(m_mainEventListener);
+}
+
+#include "UIExtraDataManager.moc"
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 51035)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 51035)
@@ -0,0 +1,60 @@
+/** @file
+ * VBox Qt GUI - UIExtraDataManager class declaration.
+ */
+
+/*
+ * Copyright (C) 2010-2013 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#ifndef ___UIExtraDataManager_h___
+#define ___UIExtraDataManager_h___
+
+/* Qt includes: */
+#include <QObject>
+
+/* COM includes: */
+#include "CEventListener.h"
+
+/* Forward declarations: */
+class UIExtraDataEventHandler;
+
+class UIExtraDataManager: public QObject
+{
+    Q_OBJECT;
+
+public:
+    static UIExtraDataManager* instance();
+    static void destroy();
+
+signals:
+    /* Specialized extra data signals */
+    void sigGUILanguageChange(QString strLang);
+    void sigSelectorShortcutsChanged();
+    void sigMachineShortcutsChanged();
+    void sigHidLedsSyncStateChanged(bool fEnabled);
+#ifdef RT_OS_DARWIN
+    void sigPresentationModeChange(bool fEnabled);
+    void sigDockIconAppearanceChange(bool fEnabled);
+#endif /* RT_OS_DARWIN */
+
+private:
+    UIExtraDataManager();
+    ~UIExtraDataManager();
+
+    /* Private member vars */
+    static UIExtraDataManager *m_pInstance;
+    CEventListener m_mainEventListener;
+    UIExtraDataEventHandler *m_pHandler;
+};
+
+#define gEDataManager UIExtraDataManager::instance()
+
+#endif /* !___UIExtraDataManager_h___ */
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIShortcutPool.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIShortcutPool.cpp	(revision 51034)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIShortcutPool.cpp	(revision 51035)
@@ -21,5 +21,5 @@
 #include "UIShortcutPool.h"
 #include "UIActionPool.h"
-#include "UIExtraDataEventHandler.h"
+#include "UIExtraDataManager.h"
 
 void UIShortcut::setDescription(const QString &strDescription)
@@ -223,6 +223,6 @@
 {
     /* Connect to extra-data signals: */
-    connect(gEDataEvents, SIGNAL(sigSelectorShortcutsChanged()), this, SLOT(sltReloadSelectorShortcuts()));
-    connect(gEDataEvents, SIGNAL(sigMachineShortcutsChanged()), this, SLOT(sltReloadMachineShortcuts()));
+    connect(gEDataManager, SIGNAL(sigSelectorShortcutsChanged()), this, SLOT(sltReloadSelectorShortcuts()));
+    connect(gEDataManager, SIGNAL(sigMachineShortcutsChanged()), this, SLOT(sltReloadMachineShortcuts()));
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 51034)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 51035)
@@ -66,5 +66,5 @@
 #include "UIActionPoolSelector.h"
 #include "UIActionPoolRuntime.h"
-#include "UIExtraDataEventHandler.h"
+#include "UIExtraDataManager.h"
 #include "QIFileDialog.h"
 #ifdef VBOX_GUI_WITH_NETWORK_MANAGER
@@ -4413,5 +4413,5 @@
     retranslateUi();
 
-    connect(gEDataEvents, SIGNAL(sigGUILanguageChange(QString)),
+    connect(gEDataManager, SIGNAL(sigGUILanguageChange(QString)),
             this, SLOT(sltGUILanguageChange(QString)));
 
@@ -4786,5 +4786,5 @@
 
     /* Destroy our event handlers */
-    UIExtraDataEventHandler::destroy();
+    UIExtraDataManager::destroy();
 
     /* Destroy the GUI root windows _BEFORE_ the media-mess, because there is
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 51034)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 51035)
@@ -56,8 +56,8 @@
 #include "UIModalWindowManager.h"
 #include "UIMedium.h"
-#include "UIExtraDataEventHandler.h"
+#include "UIExtraDataManager.h"
 #ifdef Q_WS_MAC
 # include "DockIconPreview.h"
-# include "UIExtraDataEventHandler.h"
+# include "UIExtraDataManager.h"
 #endif /* Q_WS_MAC */
 
@@ -657,5 +657,5 @@
     /* Subscribe to GUI_HidLedsSync extradata changes in order to
      * be able to enable or disable feature dynamically. */
-    connect(gEDataEvents, SIGNAL(sigHidLedsSyncStateChanged(bool)), this, SLOT(sltHidLedsSyncStateChanged(bool)));
+    connect(gEDataManager, SIGNAL(sigHidLedsSyncStateChanged(bool)), this, SLOT(sltHidLedsSyncStateChanged(bool)));
 #else
     m_isHidLedsSyncEnabled = false;
@@ -1006,5 +1006,5 @@
     connect(pDockPreviewModeGroup, SIGNAL(triggered(QAction*)),
             this, SLOT(sltDockPreviewModeChanged(QAction*)));
-    connect(gEDataEvents, SIGNAL(sigDockIconAppearanceChange(bool)),
+    connect(gEDataManager, SIGNAL(sigDockIconAppearanceChange(bool)),
             this, SLOT(sltChangeDockIconUpdate(bool)));
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp	(revision 51034)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp	(revision 51035)
@@ -28,5 +28,5 @@
 #include "UIMultiScreenLayout.h"
 #ifdef Q_WS_MAC
-# include "UIExtraDataEventHandler.h"
+# include "UIExtraDataManager.h"
 # include "VBoxUtils.h"
 # include "UIFrameBuffer.h"
@@ -386,5 +386,5 @@
      * is updated at runtime for Lion and previous: */
     if (vboxGlobal().osRelease() <= MacOSXRelease_Lion)
-        connect(gEDataEvents, SIGNAL(sigPresentationModeChange(bool)),
+        connect(gEDataManager, SIGNAL(sigPresentationModeChange(bool)),
                 this, SLOT(sltChangePresentationMode(bool)));
 }