Index: /trunk/src/VBox/Installer/win/VBoxMergeApp.wxi
===================================================================
--- /trunk/src/VBox/Installer/win/VBoxMergeApp.wxi	(revision 51038)
+++ /trunk/src/VBox/Installer/win/VBoxMergeApp.wxi	(revision 51039)
@@ -68,8 +68,8 @@
     <?if $(env.VBOX_VCC_TOOL_STEM) = "VCC100" ?>
             <!-- MS C/C++ v10.0 32 bit Runtime DLL files. -->
-            <File Id="file_msvcr100.dll_x86" Name="msvcr100.dll"
+            <File Id="file_msvcr100_x86" Name="msvcr100.dll"
                   Source="$(env.PATH_OUT)\bin\x86\msvcr100.dll"
                   DiskId="$(var.Property_DiskIdCommon)" />
-            <File Id="file_msvcp100.dll_x86" Name="msvcp100.dll"
+            <File Id="file_msvcp100_x86" Name="msvcp100.dll"
                   Source="$(env.PATH_OUT)\bin\x86\msvcp100.dll"
                   DiskId="$(var.Property_DiskIdCommon)" />
@@ -77,8 +77,8 @@
     <?if $(env.VBOX_VCC_TOOL_STEM) = "VCC110" ?>
             <!-- MS C/C++ v11.0 Runtime DLL files. -->
-            <File Id="file_msvcr110.dll_x86" Name="msvcr110.dll"
+            <File Id="file_msvcr110_x86" Name="msvcr110.dll"
                   Source="$(env.PATH_OUT)\bin\x86\msvcr110.dll"
                   DiskId="$(var.Property_DiskIdCommon)" />
-            <File Id="file_msvcp110.dll_x86" Name="msvcp110.dll"
+            <File Id="file_msvcp110_x86" Name="msvcp110.dll"
                   Source="$(env.PATH_OUT)\bin\x86\msvcp110.dll"
                   DiskId="$(var.Property_DiskIdCommon)" />
@@ -243,5 +243,5 @@
               Source="$(env.PATH_OUT)\bin\VBoxAuthSimple.dll" />
 
-        <!-- Include resource DLL (icons, ...). -->
+        <!-- Include resource DLL (icons, ...) -->
         <File Id="file_VBoxRes.dll" Name="VBoxRes.dll" DiskId="$(var.Property_DiskIdCommon)"
               Source="$(env.PATH_OUT)\bin\VBoxRes.dll" />
Index: /trunk/src/VBox/Installer/win/VBoxMergeNetAdp.wxi
===================================================================
--- /trunk/src/VBox/Installer/win/VBoxMergeNetAdp.wxi	(revision 51038)
+++ /trunk/src/VBox/Installer/win/VBoxMergeNetAdp.wxi	(revision 51039)
@@ -16,21 +16,14 @@
          xmlns:difxapp="http://schemas.microsoft.com/wix/DifxAppExtension">
 
-    <!-- Device driver directory -->
-    <Directory Id="dir_VBoxNetAdpDrivers" Name="drivers">
-        <Directory Id="dir_VBoxNetAdpNetwork" Name="network">
-            <Directory Id="dir_VBoxNetAdpNetAdp" Name="netadp">
-                <Component Id="cp_NetAdpDriver" Guid="7adf3e12-af3c-4d36-8bec-36d5064cf84f" Win64="$(var.Property_Win64)">
-                    <File Id="file_VBoxNetAdp.sys" Name="VBoxNetAdp.sys" KeyPath="yes"
-                          Source="$(env.PATH_OUT)\bin\VBoxNetAdp.sys" Checksum="yes"/>
-                    <File Id="file_VBoxNetAdp.inf" Name="VBoxNetAdp.inf"
-                          Source="$(env.PATH_OUT)\bin\VBoxNetAdp.inf" />
+    <Component Id="cp_NetAdpDriver" Guid="7adf3e12-af3c-4d36-8bec-36d5064cf84f" Win64="$(var.Property_Win64)">
+        <File Id="file_VBoxNetAdp.sys" Name="VBoxNetAdp.sys" KeyPath="yes"
+              Source="$(env.PATH_OUT)\bin\VBoxNetAdp.sys" Checksum="yes"/>
+        <File Id="file_VBoxNetAdp.inf" Name="VBoxNetAdp.inf"
+              Source="$(env.PATH_OUT)\bin\VBoxNetAdp.inf" />
 <?if $(env.VBOX_SIGNING_MODE) != none ?>
-                    <File Id="file_VBoxNetAdp.cat" Name="VBoxNetAdp.cat"
-                          Source="$(env.PATH_OUT)\bin\VBoxNetAdp.cat" />
+        <File Id="file_VBoxNetAdp.cat" Name="VBoxNetAdp.cat"
+              Source="$(env.PATH_OUT)\bin\VBoxNetAdp.cat" />
 <?endif ?>
-                </Component>
-            </Directory>
-        </Directory>
-    </Directory>
+    </Component>
 
 </Include>
Index: /trunk/src/VBox/Installer/win/VBoxMergeNetFlt.wxi
===================================================================
--- /trunk/src/VBox/Installer/win/VBoxMergeNetFlt.wxi	(revision 51038)
+++ /trunk/src/VBox/Installer/win/VBoxMergeNetFlt.wxi	(revision 51039)
@@ -16,29 +16,20 @@
          xmlns:difxapp="http://schemas.microsoft.com/wix/DifxAppExtension">
 
-    <!-- Device driver directory -->
-    <Directory Id="dir_VBoxNetFltDrivers" Name="drivers">
-
 <?if $(env.VBOX_WITH_NETFLT) = "yes" ?>
-        <Directory Id="dir_VBoxNetFltNetwork" Name="network">
-            <Directory Id="dir_VBoxNetFltNetFlt" Name="netflt">
-                <Component Id="cp_NetFltDriver" Guid="F0A02F6B-A349-42f8-A2EB-569DCAAAF846" Win64="$(var.Property_Win64)">
-                    <File Id="file_VBoxNetFlt.sys" Name="VBoxNetFlt.sys"   KeyPath="yes"
-                          Source="$(env.PATH_OUT)\bin\VBoxNetFlt.sys" Checksum="yes"/>
-                    <File Id="file_VBoxNetFltNobj.sys" Name="VBoxNetFltNobj.dll"
-                          Source="$(env.PATH_OUT)\bin\VBoxNetFltNobj.dll" Checksum="yes"/>
-                    <File Id="file_VBoxNetFltM.inf" Name="VBoxNetFltM.inf"
-                          Source="$(env.PATH_OUT)\bin\VBoxNetFltM.inf" />
-                    <File Id="file_VBoxNetFlt.inf" Name="VBoxNetFlt.inf"
-                          Source="$(env.PATH_OUT)\bin\VBoxNetFlt.inf" />
-    <?if $(env.VBOX_SIGNING_MODE) != none ?>
-                    <File Id="file_VBoxNetFlt.cat" Name="VBoxNetFlt.cat"
-                          Source="$(env.PATH_OUT)\bin\VBoxNetFlt.cat" />
-    <?endif ?>
-                </Component>
-            </Directory>
-        </Directory>
+    <Component Id="cp_NetFltDriver" Guid="F0A02F6B-A349-42f8-A2EB-569DCAAAF846" Win64="$(var.Property_Win64)">
+        <File Id="file_VBoxNetFlt.sys" Name="VBoxNetFlt.sys"   KeyPath="yes"
+              Source="$(env.PATH_OUT)\bin\VBoxNetFlt.sys" Checksum="yes"/>
+        <File Id="file_VBoxNetFltNobj.sys" Name="VBoxNetFltNobj.dll"
+              Source="$(env.PATH_OUT)\bin\VBoxNetFltNobj.dll" Checksum="yes"/>
+        <File Id="file_VBoxNetFltM.inf" Name="VBoxNetFltM.inf"
+              Source="$(env.PATH_OUT)\bin\VBoxNetFltM.inf" />
+        <File Id="file_VBoxNetFlt.inf" Name="VBoxNetFlt.inf"
+              Source="$(env.PATH_OUT)\bin\VBoxNetFlt.inf" />
+<?if $(env.VBOX_SIGNING_MODE) != none ?>
+        <File Id="file_VBoxNetFlt.cat" Name="VBoxNetFlt.cat"
+              Source="$(env.PATH_OUT)\bin\VBoxNetFlt.cat" />
+<?endif ?>
+    </Component>
 <?endif ?> <!-- VBOX_WITH_NETFLT -->
 
-    </Directory> <!-- Directory "drivers" -->
-
 </Include>