Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 51149)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 51158)
@@ -442,4 +442,9 @@
     return extraDataStringList(GUI_MachineWindowIcons, strID);
 }
+
+QString UIExtraDataManager::machineWindowNamePostfix(const QString &strID) const
+{
+    return extraDataString(GUI_MachineWindowNamePostfix, strID);
+}
 #endif /* !Q_WS_MAC */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 51149)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 51158)
@@ -129,4 +129,6 @@
     /** Except Mac OS X: Returns redefined machine-window icon names. */
     QStringList machineWindowIconNames(const QString &strID) const;
+    /** Except Mac OS X: Returns redefined machine-window name postfix. */
+    QString machineWindowNamePostfix(const QString &strID) const;
 #endif /* !Q_WS_MAC */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDefs.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDefs.cpp	(revision 51149)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDefs.cpp	(revision 51158)
@@ -53,4 +53,5 @@
 #ifndef Q_WS_MAC
 const char* UIDefs::GUI_MachineWindowIcons = "GUI/MachineWindowIcons";
+const char* UIDefs::GUI_MachineWindowNamePostfix = "GUI/MachineWindowNamePostfix";
 #endif /* !Q_WS_MAC */
 const char* UIDefs::GUI_RestrictedRuntimeMenus = "GUI/RestrictedRuntimeMenus";
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDefs.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDefs.h	(revision 51149)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDefs.h	(revision 51158)
@@ -122,4 +122,5 @@
 #ifndef Q_WS_MAC
     extern const char* GUI_MachineWindowIcons;
+    extern const char* GUI_MachineWindowNamePostfix;
 #endif /* !Q_WS_MAC */
     extern const char* GUI_RestrictedRuntimeMenus;
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 51149)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 51158)
@@ -468,5 +468,6 @@
         /* Unusual on the Mac. */
 #ifndef Q_WS_MAC
-        strMachineName += " - " + defaultWindowTitle();
+        const QString strUserProductName = uisession()->machineWindowNamePostfix();
+        strMachineName += " - " + (strUserProductName.isEmpty() ? defaultWindowTitle() : strUserProductName);
 #endif /* !Q_WS_MAC */
         if (m.GetMonitorCount() > 1)
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 51149)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 51158)
@@ -1128,4 +1128,7 @@
         if (!icon.isNull())
             m_pMachineWindowIcon = new QIcon(icon);
+
+        /* Load user's machine-window name postfix: */
+        m_strMachineWindowNamePostfix = gEDataManager->machineWindowNamePostfix(vboxGlobal().managedVMUuid());
 #endif /* !Q_WS_MAC */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 51149)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 51158)
@@ -102,4 +102,6 @@
     /** Returns redefined machine-window icon. */
     QIcon* machineWindowIcon() const { return m_pMachineWindowIcon; }
+    /** Returns redefined machine-window name postfix. */
+    QString machineWindowNamePostfix() const { return m_strMachineWindowNamePostfix; }
     /** @} */
 #endif /* !Q_WS_MAC */
@@ -354,4 +356,6 @@
     /** Holds redefined machine-window icon. */
     QIcon *m_pMachineWindowIcon;
+    /** Holds redefined machine-window name postfix. */
+    QString m_strMachineWindowNamePostfix;
     /** @} */
 #endif /* !Q_WS_MAC */