Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 51198)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 51199)
@@ -203,17 +203,27 @@
 }
 
-void UIExtraDataManager::setRecentListOfHardDrives(const QStringList &strValue)
-{
-    setExtraDataStringList(GUI_RecentListHD, strValue);
-}
-
-void UIExtraDataManager::setRecentListOfOpticalDisks(const QStringList &strValue)
-{
-    setExtraDataStringList(GUI_RecentListCD, strValue);
-}
-
-void UIExtraDataManager::setRecentListOfFloppyDisks(const QStringList &strValue)
-{
-    setExtraDataStringList(GUI_RecentListFD, strValue);
+void UIExtraDataManager::setRecentListOfHardDrives(const QStringList &value)
+{
+    setExtraDataStringList(GUI_RecentListHD, value);
+}
+
+void UIExtraDataManager::setRecentListOfOpticalDisks(const QStringList &value)
+{
+    setExtraDataStringList(GUI_RecentListCD, value);
+}
+
+void UIExtraDataManager::setRecentListOfFloppyDisks(const QStringList &value)
+{
+    setExtraDataStringList(GUI_RecentListFD, value);
+}
+
+QStringList UIExtraDataManager::suppressedMessages() const
+{
+    return extraDataStringList(GUI_SuppressMessages);
+}
+
+void UIExtraDataManager::setSuppressedMessages(const QStringList &value)
+{
+    setExtraDataStringList(GUI_SuppressMessages, value);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 51198)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 51199)
@@ -95,10 +95,15 @@
     /** Returns recent floppy-disk list. */
     QStringList recentListOfFloppyDisks() const;
-    /** Defines recent hard-drive list as @a strValue. */
-    void setRecentListOfHardDrives(const QStringList &strValue);
-    /** Defines recent optical-disk list as @a strValue. */
-    void setRecentListOfOpticalDisks(const QStringList &strValue);
-    /** Defines recent floppy-disk list as @a strValue. */
-    void setRecentListOfFloppyDisks(const QStringList &strValue);
+    /** Defines recent hard-drive list as @a value. */
+    void setRecentListOfHardDrives(const QStringList &value);
+    /** Defines recent optical-disk list as @a value. */
+    void setRecentListOfOpticalDisks(const QStringList &value);
+    /** Defines recent floppy-disk list as @a value. */
+    void setRecentListOfFloppyDisks(const QStringList &value);
+
+    /** Returns list of the supressed messages for the Message/Popup center frameworks. */
+    QStringList suppressedMessages() const;
+    /** Defines list of the supressed messages for the Message/Popup center frameworks as @a value. */
+    void setSuppressedMessages(const QStringList &value);
 
 #ifdef VBOX_GUI_WITH_NETWORK_MANAGER
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 51198)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 51199)
@@ -40,4 +40,5 @@
 #endif /* VBOX_GUI_WITH_NETWORK_MANAGER */
 #include "UIModalWindowManager.h"
+#include "UIExtraDataManager.h"
 #include "UIMedium.h"
 #ifdef VBOX_OSE
@@ -2526,6 +2527,6 @@
 void UIMessageCenter::sltResetSuppressedMessages()
 {
-    CVirtualBox vbox = vboxGlobal().virtualBox();
-    vbox.SetExtraData(GUI_SuppressMessages, QString());
+    /* Nullify suppressed message list: */
+    gEDataManager->setSuppressedMessages(QStringList());
 }
 
@@ -2713,5 +2714,5 @@
     {
         vbox = vboxGlobal().virtualBox();
-        confirmedMessageList = vbox.GetExtraData(GUI_SuppressMessages).split(',');
+        confirmedMessageList = gEDataManager->suppressedMessages();
         if (   confirmedMessageList.contains(strAutoConfirmId)
             || confirmedMessageList.contains("allMessageBoxes")
@@ -2800,5 +2801,5 @@
         {
             confirmedMessageList << strAutoConfirmId;
-            vbox.SetExtraData(GUI_SuppressMessages, confirmedMessageList.join(","));
+            gEDataManager->setSuppressedMessages(confirmedMessageList);
         }
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPopupCenter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPopupCenter.cpp	(revision 51198)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIPopupCenter.cpp	(revision 51199)
@@ -25,4 +25,5 @@
 #include "VBoxGlobal.h"
 #include "UIHostComboEditor.h"
+#include "UIExtraDataManager.h"
 
 /* Other VBox includes: */
@@ -246,5 +247,5 @@
     if ((iButton1 || iButton2) && fProposeAutoConfirmation)
     {
-        QStringList confirmedPopupList = vboxGlobal().virtualBox().GetExtraData(GUI_SuppressMessages).split(',');
+        const QStringList confirmedPopupList = gEDataManager->suppressedMessages();
         if (   confirmedPopupList.contains(strPopupPaneID)
             || confirmedPopupList.contains("allPopupPanes")
@@ -326,12 +327,7 @@
 void UIPopupCenter::sltPopupPaneDone(QString strPopupPaneID, int iResultCode)
 {
-    /* Was the result auto-confirmated? */
+    /* Remember auto-confirmation fact (if necessary): */
     if (iResultCode & AlertOption_AutoConfirmed)
-    {
-        /* Remember auto-confirmation fact: */
-        QStringList confirmedPopupList = vboxGlobal().virtualBox().GetExtraData(GUI_SuppressMessages).split(',');
-        confirmedPopupList << strPopupPaneID;
-        vboxGlobal().virtualBox().SetExtraData(GUI_SuppressMessages, confirmedPopupList.join(","));
-    }
+        gEDataManager->setSuppressedMessages(gEDataManager->suppressedMessages() << strPopupPaneID);
 
     /* Notify listeners: */