Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 51215)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 51216)
@@ -158,4 +158,37 @@
 }
 
+#ifdef VBOX_GUI_WITH_NETWORK_MANAGER
+QString UIExtraDataManager::applicationUpdateData() const
+{
+    return extraDataString(GUI_UpdateDate);
+}
+
+void UIExtraDataManager::setApplicationUpdateData(const QString &strValue)
+{
+    setExtraDataString(GUI_UpdateDate, strValue);
+}
+
+qulonglong UIExtraDataManager::applicationUpdateCheckCounter() const
+{
+    /* Read subsequent update check counter value: */
+    qulonglong uResult = 1;
+    const QString strCheckCount = extraDataString(GUI_UpdateCheckCount);
+    if (!strCheckCount.isEmpty())
+    {
+        bool ok = false;
+        int uCheckCount = strCheckCount.toULongLong(&ok);
+        if (ok) uResult = uCheckCount;
+    }
+    /* Return update check counter value: */
+    return uResult;
+}
+
+void UIExtraDataManager::incrementApplicationUpdateCheckCounter()
+{
+    /* Increment update check counter value: */
+    setExtraDataString(GUI_UpdateCheckCount, QString::number(applicationUpdateCheckCounter() + 1));
+}
+#endif /* VBOX_GUI_WITH_NETWORK_MANAGER */
+
 QString UIExtraDataManager::recentFolderForHardDrives() const
 {
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 51215)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 51216)
@@ -75,4 +75,15 @@
     /** Returns version for which user wants to prevent BETA warning. */
     QString preventBETAwarningForVersion() const;
+
+#ifdef VBOX_GUI_WITH_NETWORK_MANAGER
+    /** Returns last application update date. */
+    QString applicationUpdateData() const;
+    /** Defines last application update date as @a strValue. */
+    void setApplicationUpdateData(const QString &strValue);
+    /** Returns application update check counter. */
+    qulonglong applicationUpdateCheckCounter() const;
+    /** Increments application update check counter. */
+    void incrementApplicationUpdateCheckCounter();
+#endif /* VBOX_GUI_WITH_NETWORK_MANAGER */
 
     /** Returns recent hard-drive folder. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/net/UIUpdateManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/net/UIUpdateManager.cpp	(revision 51215)
+++ trunk/src/VBox/Frontends/VirtualBox/src/net/UIUpdateManager.cpp	(revision 51216)
@@ -162,14 +162,4 @@
     void prepareNetworkRequest()
     {
-        /* Calculate the count of checks left: */
-        int cCount = 1;
-        QString strCount = vboxGlobal().virtualBox().GetExtraData(GUI_UpdateCheckCount);
-        if (!strCount.isEmpty())
-        {
-            bool ok = false;
-            int c = strCount.toLongLong(&ok);
-            if (ok) cCount = c;
-        }
-
         /* Compose query: */
         QUrl url(m_url);
@@ -190,6 +180,6 @@
                                                         .arg(vboxGlobal().virtualBox().GetRevision()));
         }
-        url.addQueryItem("count", QString::number(cCount));
-        url.addQueryItem("branch", VBoxUpdateData(vboxGlobal().virtualBox().GetExtraData(GUI_UpdateDate)).branchName());
+        url.addQueryItem("count", QString::number(gEDataManager->applicationUpdateCheckCounter()));
+        url.addQueryItem("branch", VBoxUpdateData(gEDataManager->applicationUpdateData()).branchName());
         QString strUserAgent(QString("VirtualBox %1 <%2>").arg(vboxGlobal().virtualBox().GetVersion()).arg(platformInfo()));
 
@@ -227,14 +217,6 @@
         }
 
-        /* Save left count of checks: */
-        int cCount = 1;
-        QString strCount = vboxGlobal().virtualBox().GetExtraData(GUI_UpdateCheckCount);
-        if (!strCount.isEmpty())
-        {
-            bool ok = false;
-            int c = strCount.toLongLong(&ok);
-            if (ok) cCount = c;
-        }
-        vboxGlobal().virtualBox().SetExtraData(GUI_UpdateCheckCount, QString("%1").arg((qulonglong)cCount + 1));
+        /* Increment update check counter: */
+        gEDataManager->incrementApplicationUpdateCheckCounter();
 
         /* Notify about step completion: */
@@ -491,5 +473,5 @@
 
     /* Load/decode curent update data: */
-    VBoxUpdateData currentData(vboxGlobal().virtualBox().GetExtraData(GUI_UpdateDate));
+    VBoxUpdateData currentData(gEDataManager->applicationUpdateData());
 
     /* If update is really necessary: */
@@ -509,8 +491,8 @@
 {
     /* Load/decode curent update data: */
-    VBoxUpdateData currentData(vboxGlobal().virtualBox().GetExtraData(GUI_UpdateDate));
+    VBoxUpdateData currentData(gEDataManager->applicationUpdateData());
     /* Encode/save new update data: */
     VBoxUpdateData newData(currentData.periodIndex(), currentData.branchIndex());
-    vboxGlobal().virtualBox().SetExtraData(GUI_UpdateDate, newData.data());
+    gEDataManager->setApplicationUpdateData(newData.data());
 
 #ifdef VBOX_WITH_UPDATE_REQUEST
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsUpdate.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsUpdate.cpp	(revision 51215)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsUpdate.cpp	(revision 51216)
@@ -20,4 +20,5 @@
 /* GUI includes: */
 #include "UIGlobalSettingsUpdate.h"
+#include "UIExtraDataManager.h"
 #include "VBoxGlobal.h"
 
@@ -48,5 +49,5 @@
 
     /* Fill internal variables with corresponding values: */
-    VBoxUpdateData updateData(vboxGlobal().virtualBox().GetExtraData(GUI_UpdateDate));
+    VBoxUpdateData updateData(gEDataManager->applicationUpdateData());
     m_cache.m_fCheckEnabled = !updateData.isNoNeedToCheck();
     m_cache.m_periodIndex = updateData.periodIndex();
@@ -103,5 +104,5 @@
     /* Gather corresponding values from internal variables: */
     VBoxUpdateData newData(m_cache.m_periodIndex, m_cache.m_branchIndex);
-    vboxGlobal().virtualBox().SetExtraData(GUI_UpdateDate, newData.data());
+    gEDataManager->setApplicationUpdateData(newData.data());
 
     /* Upload properties & settings to data: */