Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp	(revision 51248)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp	(revision 51249)
@@ -109,5 +109,8 @@
     /* Get sender machine-window: */
     UIMachineWindow *pMachineWindow = qobject_cast<UIMachineWindow*>(sender());
-    AssertReturnVoid(pMachineWindow);
+    AssertPtrReturnVoid(pMachineWindow);
+    LogRel(("UIMachineLogicFullscreen::sltHandleNativeFullscreenWillEnter: "
+            "Machine-window #%d will enter native fullscreen.\n",
+            (int)pMachineWindow->screenId()));
 
     /* Fade to black: */
@@ -122,5 +125,8 @@
     /* Get sender machine-window: */
     UIMachineWindow *pMachineWindow = qobject_cast<UIMachineWindow*>(sender());
-    AssertReturnVoid(pMachineWindow);
+    AssertPtrReturnVoid(pMachineWindow);
+    LogRel(("UIMachineLogicFullscreen::sltHandleNativeFullscreenDidEnter: "
+            "Machine-window #%d did enter native fullscreen.\n",
+            (int)pMachineWindow->screenId()));
 
     /* Add machine-window to corresponding set: */
@@ -146,5 +152,8 @@
     /* Get sender machine-window: */
     UIMachineWindow *pMachineWindow = qobject_cast<UIMachineWindow*>(sender());
-    AssertReturnVoid(pMachineWindow);
+    AssertPtrReturnVoid(pMachineWindow);
+    LogRel(("UIMachineLogicFullscreen::sltHandleNativeFullscreenWillExit: "
+            "Machine-window #%d will exit native fullscreen.\n",
+            (int)pMachineWindow->screenId()));
 
     /* Fade to black: */
@@ -159,5 +168,5 @@
     /* Get sender machine-window: */
     UIMachineWindow *pMachineWindow = qobject_cast<UIMachineWindow*>(sender());
-    AssertReturnVoid(pMachineWindow);
+    AssertPtrReturnVoid(pMachineWindow);
 
     /* Remove machine-window from corresponding set: */
@@ -175,5 +184,5 @@
     {
         LogRel(("UIMachineLogicFullscreen::sltHandleNativeFullscreenDidExit: "
-                "Machine-window #%d exited invalidated fullscreen, revalidate it.\n",
+                "Machine-window #%d exited invalidated native fullscreen, revalidate it.\n",
                 (int)pMachineWindow->screenId()));
 
@@ -182,5 +191,5 @@
 
         /* Revalidate 'fullscreen' window: */
-        revalidateFullscreenWindow(pMachineWindow);
+        revalidateNativeFullScreen(pMachineWindow);
     }
     /* If there are no invalidated windows: */
@@ -191,5 +200,6 @@
         {
             LogRel(("UIMachineLogicFullscreen::sltHandleNativeFullscreenDidExit: "
-                    "Machine-window exited fullscreen, asking others to exit too...\n"));
+                    "Machine-window #%d exited native fullscreen, asking others to exit too...\n",
+                    (int)pMachineWindow->screenId()));
 
             /* Ask window(s) to exit 'fullscreen' mode: */
@@ -200,5 +210,6 @@
         {
             LogRel(("UIMachineLogicFullscreen::sltHandleNativeFullscreenDidExit: "
-                    "Machine-window(s) exited fullscreen, changing visual-state to requested...\n"));
+                    "Machine-window #%d exited native fullscreen, changing visual-state to requested...\n",
+                    (int)pMachineWindow->screenId()));
 
             /* Change visual-state to requested: */
@@ -350,5 +361,5 @@
 void UIMachineLogicFullscreen::sltScreenLayoutChanged()
 {
-    LogRel(("UIMachineLogicFullscreen: Multi-screen layout changed.\n"));
+    LogRel(("UIMachineLogicFullscreen::sltScreenLayoutChanged: Multi-screen layout changed.\n"));
 
 #ifdef Q_WS_MAC
@@ -363,5 +374,5 @@
     }
     /* Revalidate 'fullscreen' windows for ML and next: */
-    else revalidateFullscreenWindows();
+    else revalidateNativeFullScreen();
 #else /* !Q_WS_MAC */
     /* Make sure all machine-window(s) have proper geometry: */
@@ -373,5 +384,5 @@
 void UIMachineLogicFullscreen::sltGuestMonitorChange(KGuestMonitorChangedEventType changeType, ulong uScreenId, QRect screenGeo)
 {
-    LogRel(("UIMachineLogicFullscreen: Guest-screen count changed.\n"));
+    LogRel(("UIMachineLogicFullscreen::sltGuestMonitorChange: Guest-screen count changed.\n"));
 
     /* Update multi-screen layout before any window update: */
@@ -385,5 +396,5 @@
         UIMachineLogic::sltGuestMonitorChange(changeType, uScreenId, screenGeo);
     /* Revalidate 'fullscreen' windows for ML and next: */
-    else revalidateFullscreenWindows();
+    else revalidateNativeFullScreen();
 #else /* !Q_WS_MAC */
     /* Call to base-class: */
@@ -394,5 +405,5 @@
 void UIMachineLogicFullscreen::sltHostScreenCountChanged()
 {
-    LogRel(("UIMachineLogicFullscreen: Host-screen count changed.\n"));
+    LogRel(("UIMachineLogicFullscreen::sltHostScreenCountChanged: Host-screen count changed.\n"));
 
     /* Update multi-screen layout before any window update: */
@@ -404,5 +415,5 @@
         UIMachineLogic::sltHostScreenCountChanged();
     /* Revalidate 'fullscreen' windows for ML and next: */
-    else revalidateFullscreenWindows();
+    else revalidateNativeFullScreen();
 #else /* !Q_WS_MAC */
     /* Call to base-class: */
@@ -518,5 +529,5 @@
         }
         /* Revalidate 'fullscreen' windows: */
-        revalidateFullscreenWindows();
+        revalidateNativeFullScreen();
     }
 #endif /* Q_WS_MAC */
@@ -639,4 +650,5 @@
 
     /* Acquire fade-token: */
+    LogRel(("UIMachineLogicFullscreen::fadeToBlack\n"));
     CGAcquireDisplayFadeReservation(kCGMaxDisplayReservationInterval, &m_fadeToken);
     CGDisplayFade(m_fadeToken, 0.3, kCGDisplayBlendNormal, kCGDisplayBlendSolidColor, 0.0, 0.0, 0.0, true);
@@ -650,4 +662,5 @@
 
     /* Release fade-token: */
+    LogRel(("UIMachineLogicFullscreen::fadeToNormal\n"));
     CGDisplayFade(m_fadeToken, 0.5, kCGDisplayBlendSolidColor, kCGDisplayBlendNormal, 0.0, 0.0, 0.0, false);
     CGReleaseDisplayFadeReservation(m_fadeToken);
@@ -655,8 +668,6 @@
 }
 
-void UIMachineLogicFullscreen::revalidateFullscreenWindow(UIMachineWindow *pMachineWindow)
-{
-    LogRel(("UIMachineLogicFullscreen::revalidateFullscreenWindow #%d begin.\n", pMachineWindow->screenId()));
-
+void UIMachineLogicFullscreen::revalidateNativeFullScreen(UIMachineWindow *pMachineWindow)
+{
     /* Make sure window is not already invalidated: */
     if (m_invalidFullscreenMachineWindows.contains(pMachineWindow))
@@ -669,8 +680,13 @@
     /* Get screen ID: */
     ulong uScreenID = pMachineWindow->screenId();
+    LogRel(("UIMachineLogicFullscreen::revalidateNativeFullScreen: For machine-window #%d.\n",
+            (int)uScreenID));
 
     /* Validate window which can't be fullscreen: */
     if (uScreenID != 0 && !darwinScreensHaveSeparateSpaces())
     {
+        LogRel(("UIMachineLogicFullscreen::revalidateNativeFullScreen: "
+                "Ask machine-window #%d to show/normalize.\n", (int)uScreenID));
+
         /* Make sure window have proper geometry: */
         pMachineWindow->showInNecessaryMode();
@@ -688,6 +704,6 @@
                 && hasHostScreenForGuestScreen(uScreenID))
             {
-                LogRel(("UIMachineLogicFullscreen::revalidateFullscreenWindow: "
-                        "Ask machine-window #%d to enter fullscreen.\n", (int)uScreenID));
+                LogRel(("UIMachineLogicFullscreen::revalidateNativeFullScreen: "
+                        "Ask machine-window #%d to enter native fullscreen.\n", (int)uScreenID));
 
                 /* Fade to black: */
@@ -707,4 +723,7 @@
             else if (pMachineWindow->isVisible())
             {
+                LogRel(("UIMachineLogicFullscreen::revalidateNativeFullScreen: "
+                        "Ask machine-window #%d to hide.\n", (int)uScreenID));
+
                 /* Else make sure that window is hidden: */
                 pMachineWindow->showInNecessaryMode();
@@ -733,6 +752,6 @@
                 || frameBufferSize != screenSize)
             {
-                LogRel(("UIMachineLogicFullscreen::revalidateFullscreenWindow: "
-                        "Ask machine-window #%d to exit fullscreen.\n", (int)uScreenID));
+                LogRel(("UIMachineLogicFullscreen::revalidateNativeFullScreen: "
+                        "Ask machine-window #%d to exit native fullscreen.\n", (int)uScreenID));
 
                 /* Fade to black: */
@@ -747,13 +766,11 @@
         }
     }
-
-    LogRel(("UIMachineLogicFullscreen::revalidateFullscreenWindow #%d end.\n", pMachineWindow->screenId()));
-}
-
-void UIMachineLogicFullscreen::revalidateFullscreenWindows()
+}
+
+void UIMachineLogicFullscreen::revalidateNativeFullScreen()
 {
     /* Revalidate all fullscreen windows: */
     foreach (UIMachineWindow *pMachineWindow, machineWindows())
-        revalidateFullscreenWindow(pMachineWindow);
+        revalidateNativeFullScreen(pMachineWindow);
 }
 #endif /* Q_WS_MAC */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.h	(revision 51248)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.h	(revision 51249)
@@ -123,7 +123,7 @@
 
     /** Mac OS X: Revalidates 'fullscreen' mode for @a pMachineWindow. */
-    void revalidateFullscreenWindow(UIMachineWindow *pMachineWindow);
+    void revalidateNativeFullScreen(UIMachineWindow *pMachineWindow);
     /** Mac OS X: Revalidates 'fullscreen' mode for all windows. */
-    void revalidateFullscreenWindows();
+    void revalidateNativeFullScreen();
 #endif /* Q_WS_MAC */
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineLogicNormal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineLogicNormal.cpp	(revision 51248)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineLogicNormal.cpp	(revision 51249)
@@ -56,5 +56,6 @@
             if (uisession()->isGuestSupportsSeamless())
             {
-                LogRel(("UIMachineLogicNormal: Going 'seamless' as requested...\n"));
+                LogRel(("UIMachineLogicNormal::sltCheckForRequestedVisualStateType: "
+                        "Going 'seamless' as requested...\n"));
                 uisession()->setRequestedVisualState(UIVisualStateType_Invalid);
                 uisession()->changeVisualState(UIVisualStateType_Seamless);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineLogicSeamless.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineLogicSeamless.cpp	(revision 51248)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineLogicSeamless.cpp	(revision 51249)
@@ -118,5 +118,6 @@
     if (!uisession()->isGuestSupportsSeamless())
     {
-        LogRel(("UIMachineLogicSeamless: Leaving 'seamless' as it is no more supported...\n"));
+        LogRel(("UIMachineLogicSeamless::sltCheckForRequestedVisualStateType: "
+                "Leaving 'seamless' as it is no more supported...\n"));
         uisession()->setRequestedVisualState(UIVisualStateType_Seamless);
         uisession()->changeVisualState(UIVisualStateType_Normal);