Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 51280)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 51287)
@@ -65,4 +65,5 @@
         <file alias="expanding_collapsing_16px.png">images/expanding_collapsing_16px.png</file>
         <file alias="export_16px.png">images/export_16px.png</file>
+        <file alias="extension_pack_16px.png">images/extension_pack_16px.png</file>
         <file alias="extension_pack_24px.png">images/extension_pack_24px.png</file>
         <file alias="extension_pack_32px.png">images/extension_pack_32px.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 51280)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 51287)
@@ -42,4 +42,5 @@
         <file alias="progress_state_restore_90px.png">images/progress_state_restore_90px.png</file>
         <file alias="progress_state_save_90px.png">images/progress_state_save_90px.png</file>
+        <file alias="proxy_16px.png">images/proxy_16px.png</file>
         <file alias="proxy_24px.png">images/proxy_24px.png</file>
         <file alias="proxy_32px.png">images/proxy_32px.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialog.cpp	(revision 51280)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialog.cpp	(revision 51287)
@@ -270,4 +270,5 @@
 
 void UISettingsDialog::addItem(const QString &strBigIcon,
+                               const QString &strMediumIcon,
                                const QString &strSmallIcon,
                                int cId,
@@ -277,5 +278,5 @@
 {
     /* Add new selector item: */
-    if (QWidget *pPage = m_pSelector->addItem(strBigIcon, strSmallIcon,
+    if (QWidget *pPage = m_pSelector->addItem(strBigIcon, strMediumIcon, strSmallIcon,
                                               cId, strLink, pSettingsPage, iParentId))
     {
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialog.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialog.h	(revision 51280)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialog.h	(revision 51287)
@@ -86,5 +86,5 @@
 
     /* Add settings page: */
-    void addItem(const QString &strBigIcon, const QString &strSmallIcon,
+    void addItem(const QString &strBigIcon, const QString &strMediumIcon, const QString &strSmallIcon,
                  int cId, const QString &strLink,
                  UISettingsPage* pSettingsPage = 0, int iParentId = -1);
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.cpp	(revision 51280)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.cpp	(revision 51287)
@@ -342,5 +342,5 @@
                 {
                     pSettingsPage = new UIGlobalSettingsGeneral;
-                    addItem(":/machine_32px.png", ":/machine_24px.png",
+                    addItem(":/machine_32px.png", ":/machine_24px.png", ":/machine_16px.png",
                             iPageIndex, "#general", pSettingsPage);
                     break;
@@ -350,5 +350,5 @@
                 {
                     pSettingsPage = new UIGlobalSettingsInput;
-                    addItem(":/hostkey_32px.png", ":/hostkey_24px.png",
+                    addItem(":/hostkey_32px.png", ":/hostkey_24px.png", ":/hostkey_16px.png",
                             iPageIndex, "#input", pSettingsPage);
                     break;
@@ -359,5 +359,5 @@
                 {
                     pSettingsPage = new UIGlobalSettingsUpdate;
-                    addItem(":/refresh_32px.png", ":/refresh_24px.png",
+                    addItem(":/refresh_32px.png", ":/refresh_24px.png", ":/refresh_16px.png",
                             iPageIndex, "#update", pSettingsPage);
                     break;
@@ -368,5 +368,5 @@
                 {
                     pSettingsPage = new UIGlobalSettingsLanguage;
-                    addItem(":/site_32px.png", ":/site_24px.png",
+                    addItem(":/site_32px.png", ":/site_24px.png", ":/site_16px.png",
                             iPageIndex, "#language", pSettingsPage);
                     break;
@@ -376,5 +376,5 @@
                 {
                     pSettingsPage = new UIGlobalSettingsDisplay;
-                    addItem(":/vrdp_32px.png", ":/vrdp_24px.png",
+                    addItem(":/vrdp_32px.png", ":/vrdp_24px.png", ":/vrdp_16px.png",
                             iPageIndex, "#display", pSettingsPage);
                     break;
@@ -384,5 +384,5 @@
                 {
                     pSettingsPage = new UIGlobalSettingsNetwork;
-                    addItem(":/nw_32px.png", ":/nw_24px.png",
+                    addItem(":/nw_32px.png", ":/nw_24px.png", ":/nw_16px.png",
                             iPageIndex, "#network", pSettingsPage);
                     break;
@@ -392,5 +392,5 @@
                 {
                     pSettingsPage = new UIGlobalSettingsExtension;
-                    addItem(":/extension_pack_32px.png", ":/extension_pack_24px.png",
+                    addItem(":/extension_pack_32px.png", ":/extension_pack_24px.png", ":/extension_pack_16px.png",
                             iPageIndex, "#extensions", pSettingsPage);
                     break;
@@ -401,5 +401,5 @@
                 {
                     pSettingsPage = new UIGlobalSettingsProxy;
-                    addItem(":/proxy_32px.png", ":/proxy_24px.png",
+                    addItem(":/proxy_32px.png", ":/proxy_24px.png", ":/proxy_16px.png",
                             iPageIndex, "#proxy", pSettingsPage);
                     break;
@@ -581,5 +581,5 @@
                 {
                     pSettingsPage = new UIMachineSettingsGeneral;
-                    addItem(":/machine_32px.png", ":/machine_24px.png",
+                    addItem(":/machine_32px.png", ":/machine_24px.png", ":/machine_16px.png",
                             iPageIndex, "#general", pSettingsPage);
                     break;
@@ -589,5 +589,5 @@
                 {
                     pSettingsPage = new UIMachineSettingsSystem;
-                    addItem(":/chipset_32px.png", ":/chipset_24px.png",
+                    addItem(":/chipset_32px.png", ":/chipset_24px.png", ":/chipset_16px.png",
                             iPageIndex, "#system", pSettingsPage);
                     break;
@@ -597,5 +597,5 @@
                 {
                     pSettingsPage = new UIMachineSettingsDisplay;
-                    addItem(":/vrdp_32px.png", ":/vrdp_24px.png",
+                    addItem(":/vrdp_32px.png", ":/vrdp_24px.png", ":/vrdp_16px.png",
                             iPageIndex, "#display", pSettingsPage);
                     break;
@@ -606,5 +606,5 @@
                     pSettingsPage = new UIMachineSettingsStorage;
                     connect(pSettingsPage, SIGNAL(storageChanged()), this, SLOT(sltResetFirstRunFlag()));
-                    addItem(":/hd_32px.png", ":/hd_24px.png",
+                    addItem(":/hd_32px.png", ":/hd_24px.png", ":/hd_16px.png",
                             iPageIndex, "#storage", pSettingsPage);
                     break;
@@ -614,5 +614,5 @@
                 {
                     pSettingsPage = new UIMachineSettingsAudio;
-                    addItem(":/sound_32px.png", ":/sound_24px.png",
+                    addItem(":/sound_32px.png", ":/sound_24px.png", ":/sound_16px.png",
                             iPageIndex, "#audio", pSettingsPage);
                     break;
@@ -622,5 +622,5 @@
                 {
                     pSettingsPage = new UIMachineSettingsNetworkPage;
-                    addItem(":/nw_32px.png", ":/nw_24px.png",
+                    addItem(":/nw_32px.png", ":/nw_24px.png", ":/nw_16px.png",
                             iPageIndex, "#network", pSettingsPage);
                     break;
@@ -629,5 +629,5 @@
                 case MachineSettingsPageType_Ports:
                 {
-                    addItem(":/serial_port_32px.png", ":/serial_port_24px.png",
+                    addItem(":/serial_port_32px.png", ":/serial_port_24px.png", ":/serial_port_16px.png",
                             iPageIndex, "#ports");
                     break;
@@ -637,5 +637,5 @@
                 {
                     pSettingsPage = new UIMachineSettingsSerialPage;
-                    addItem(":/serial_port_32px.png", ":/serial_port_24px.png",
+                    addItem(":/serial_port_32px.png", ":/serial_port_24px.png", ":/serial_port_16px.png",
                             iPageIndex, "#serialPorts", pSettingsPage, MachineSettingsPageType_Ports);
                     break;
@@ -645,5 +645,5 @@
                 {
                     pSettingsPage = new UIMachineSettingsParallelPage;
-                    addItem(":/parallel_port_32px.png", ":/parallel_port_24px.png",
+                    addItem(":/parallel_port_32px.png", ":/parallel_port_24px.png", ":/parallel_port_16px.png",
                             iPageIndex, "#parallelPorts", pSettingsPage, MachineSettingsPageType_Ports);
                     break;
@@ -653,5 +653,5 @@
                 {
                     pSettingsPage = new UIMachineSettingsUSB;
-                    addItem(":/usb_32px.png", ":/usb_24px.png",
+                    addItem(":/usb_32px.png", ":/usb_24px.png", ":/usb_16px.png",
                             iPageIndex, "#usb", pSettingsPage, MachineSettingsPageType_Ports);
                     break;
@@ -661,5 +661,5 @@
                 {
                     pSettingsPage = new UIMachineSettingsSF;
-                    addItem(":/sf_32px.png", ":/sf_24px.png",
+                    addItem(":/sf_32px.png", ":/sf_24px.png", ":/sf_16px.png",
                             iPageIndex, "#sharedFolders", pSettingsPage);
                     break;
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/VBoxSettingsSelector.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/VBoxSettingsSelector.cpp	(revision 51280)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/VBoxSettingsSelector.cpp	(revision 51287)
@@ -210,6 +210,7 @@
 }
 
-QWidget *VBoxSettingsTreeViewSelector::addItem (const QString & /* aBigIcon */,
-                                                const QString &aSmallIcon,
+QWidget *VBoxSettingsTreeViewSelector::addItem (const QString & /* strBigIcon */,
+                                                const QString &strMediumIcon ,
+                                                const QString & /* strSmallIcon */,
                                                 int aId,
                                                 const QString &aLink,
@@ -220,5 +221,5 @@
     if (aPage != NULL)
     {
-        QIcon icon = UIIconPool::iconSet(aSmallIcon);
+        QIcon icon = UIIconPool::iconSet(strMediumIcon);
 
         SelectorItem *item = new SelectorItem (icon, "", aId, aLink, aPage, aParentId);
@@ -400,6 +401,7 @@
 }
 
-QWidget *VBoxSettingsToolBarSelector::addItem (const QString &aBigIcon,
-                                               const QString &aSmallIcon,
+QWidget *VBoxSettingsToolBarSelector::addItem (const QString &strBigIcon,
+                                               const QString & /* strMediumIcon */,
+                                               const QString &strSmallIcon,
                                                int aId,
                                                const QString &aLink,
@@ -407,5 +409,5 @@
                                                int aParentId /* = -1 */)
 {
-    QIcon icon = UIIconPool::iconSet(aBigIcon);
+    QIcon icon = UIIconPool::iconSet(strBigIcon);
 
     QWidget *result = NULL;
@@ -428,5 +430,5 @@
         mTbSelector->addAction (item->action());
         QITabWidget *tabWidget= new QITabWidget();
-        tabWidget->setIconSize(QSize(24, 24));
+        tabWidget->setIconSize(QSize(16, 16));
         tabWidget->setContentsMargins (0, 0, 0, 0);
 //        connect (tabWidget, SIGNAL (currentChanged (int)),
@@ -443,5 +445,5 @@
             aPage->setContentsMargins (9, 5, 9, 9);
             aPage->layout()->setContentsMargins(0, 0, 0, 0);
-            QIcon icon1 = UIIconPool::iconSet(aSmallIcon);
+            QIcon icon1 = UIIconPool::iconSet(strSmallIcon);
             if (tabWidget)
                 tabWidget->addTab (aPage, icon1, "");
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/VBoxSettingsSelector.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/VBoxSettingsSelector.h	(revision 51280)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/VBoxSettingsSelector.h	(revision 51287)
@@ -48,5 +48,6 @@
     virtual QWidget *widget() const = 0;
 
-    virtual QWidget *addItem (const QString &aBigIcon, const QString &aSmallIcon, int aId, const QString &aLink, UISettingsPage* aPage = NULL, int aParentId = -1) = 0;
+    virtual QWidget *addItem (const QString &strBigIcon, const QString &strMediumIcon, const QString &strSmallIcon,
+                              int aId, const QString &aLink, UISettingsPage* aPage = NULL, int aParentId = -1) = 0;
 
     virtual void setItemText (int aId, const QString &aText);
@@ -97,5 +98,6 @@
     virtual QWidget *widget() const;
 
-    virtual QWidget *addItem (const QString &aBigIcon, const QString &aSmallIcon, int aId, const QString &aLink, UISettingsPage* aPage = NULL, int aParentId = -1);
+    virtual QWidget *addItem (const QString &strBigIcon, const QString &strMediumIcon, const QString &strSmallIcon,
+                              int aId, const QString &aLink, UISettingsPage* aPage = NULL, int aParentId = -1);
     virtual void setItemText (int aId, const QString &aText);
     virtual QString itemText (int aId) const;
@@ -137,5 +139,6 @@
     virtual QWidget *widget() const;
 
-    virtual QWidget *addItem (const QString &aBigIcon, const QString &aSmallIcon, int aId, const QString &aLink, UISettingsPage* aPage = NULL, int aParentId = -1);
+    virtual QWidget *addItem (const QString &strBigIcon, const QString &strMediumIcon, const QString &strSmallIcon,
+                              int aId, const QString &aLink, UISettingsPage* aPage = NULL, int aParentId = -1);
     virtual void setItemText (int aId, const QString &aText);
     virtual QString itemText (int aId) const;